import pickle, os, pygame

class HighScores:
    """A class for tracking high scores."""
    def __init__(self):
        self.theList = []
        self.readFile()
        
    def readFile(self):
        filename = os.path.join("highscores.txt")
        try:
            highscores = open(filename, "r")
            self.theList = pickle.load(highscores)
            highscores.close()
        except IOError:
            print "Oops! I can't seem to find a highscore list!"
            print "Creating a new one..."
            self.createNew()
            print "New high score list created."    

    def addScore(self, user, score):
        tempList = []
        count = 0
        
        while score <= self.theList[count][1]:
            tempList.append(self.theList[count])
            count += 1
            
        tempList.append([user, score])
        count += 1
        
        while count < 10:
            tempList.append(self.theList[count - 1])
            count += 1

        self.theList = tempList
            
    def createNew(self):
        self.theList = [ ["Moriah", 100000],
                         ["Daniel", 90000], 
                         ["Bear", 80000], 
                         ["Tony", 70000], 
                         ["Mom", 60000], 
                         ["Dad", 50000], 
                         ["Bean", 40000], 
                         ["Patrick", 30000], 
                         ["Jaimie", 20000], 
                         ["Michael", 10000] ]
        self.writeFile()
    
    def writeFile(self):
        filename = os.path.join("highscores.txt")
        try:
            highscores = open(filename, "w")
            pickle.dump(self.theList, highscores)
            highscores.close()
        except IOError:
            print "Oops! Can't create new high score file!"
            raise SystemExit
        
    def printList(self):
        for record in self.theList:
            print str(record[0]) + ": " + str(record[1])
            
    def drawToScreen(self, initalX, initalY):
        font = pygame.font.Font(os.path.join("data", "Brisk.ttf"), 30)
        color = (255, 255, 255, 255)
        
        screen = pygame.display.get_surface()
        
        text = font.render("High Scores", 1, color)
        textLoc = text.get_rect()
        textLoc = textLoc.move(initalX + 100, initalY)
        screen.blit(text, textLoc)
        
        for i in range(10):
            rank = str(i + 1)
            user = str(self.theList[i][0])
            score = str(self.theList[i][1])
            
            text = font.render(rank, 1, color)
            textLoc = text.get_rect()
            textLoc = textLoc.move(initalX, initalY + 40 + (i * 30))
            screen.blit(text, textLoc)
            
            text = font.render(user, 1, color)
            textLoc = text.get_rect()
            textLoc = textLoc.move(initalX + 50, initalY + 40 + (i * 30))
            screen.blit(text, textLoc)
            
            text = font.render(score, 1, color)
            textLoc = text.get_rect()
            textLoc = textLoc.move(initalX + 220, initalY + 40 + (i * 30))
            screen.blit(text, textLoc)
            
        pygame.display.flip()
        
    def getLowScore(self):
        return self.theList[9][1]

            
if __name__ == "__main__":
    hello = HighScores()
    hello.createNew()
    # hello.addScore("Cowz", 200000)
    # hello.printList()
    # print
    # 
    # hello.addScore("Cowz", 95000)
    # hello.printList()
    # print
    # 
    # hello.addScore("Nichael", 31000)
    # hello.printList()
    # print "Finished."